// Layout for a dimension card

<template>
  <li>
    <div class="row">
      <div
        v-tooltip="{
          placement: 'top-center',
          content: indicatorTooltip,
          delay: { show: 500, hide: 100 }
        }"
        class="col text-truncate"
      >
        <!-- Key (e.g. "Spatial Availability") -->
        {{ indicator }}
      </div>
      <div
        v-tooltip="{
          placement: 'top-center',
          content: percentageHintTooltip,
          delay: { show: 500, hide: 100 }
        }"
        class="col-auto text-right"
      >
        <span v-if="displayName" :class="{'text-monospace' : primaryValue}">
          <!-- Display indicator value name e.g. "200" -->
          {{ primaryValue | formatName }}
        </span>
        <span v-else>
          <!-- Display indicator value percentage (e.g. "78%")  -->
          {{ primaryValue | formatValue }}
        </span>
      </div>
    </div>
  </li>
</template>

<script>

export default {
  name: 'DimensionsItemIndicator',
  filters: {
    formatName (value) {
      if (!value) return '??'
      return `${value.name}` || '??'
    },
    formatValue (value) {
      if (!value) return '??'
      return value.percentage || value.percentage === 0
        ? `${value.percentage}%`
        : '??'
    }
  },
  props: {
    // Name for this indicator e.g. "License available"
    indicator: {
      type: String,
      default: ''
    },
    // Array containing every indicator feature value of this indicator
    // e.g. [{name: "yes", percentage: 89}, {name: "no", percentage: 11}]
    values: {
      type: Array,
      default () {
        return []
      }
    },
    filterPrimaryValue: {
      type: String | Function,
      default: undefined
    },
    displayName: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    // Returns for this indicator the 'primary' metric, if filterPrimaryValue is set.
    // The filterPrimaryValue can be either a String e.g. '200' or a function.
    // If it's a String, then primaryValue returns a value object for this indicator such that value.name === filterPrimaryValue
    // If it's a function, it will return filterPrimaryValue(values)
    // For example, for indicator 'most frequent acessURLs', the filterPrimaryValue is a function that returns that maximum indicator metric e.g. '200'
    primaryValue () {
      if (!this.values || this.values.length === 0) return null
      let primary = this.filterPrimaryValue ? this.filterPrimaryValue : this.values[0]

      if (typeof primary === 'function') {
        return primary(this.values) || this.values[0]
      }

      const value = this.values.find(value => value.name === primary.name)
      return value || this.values[0]
    },
    indicatorTooltip () {
      return `${this.indicator}`
    },
    percentageHintTooltip () {
      if (!this.displayName || !this.primaryValue) return ''
      return this.primaryValue.percentage ? `${this.primaryValue.percentage}%` : ''
    }
  }
}
</script>

<style lang="scss" scoped>
@import "@/styles/metrics-style.scss";
</style>
